<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "https://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=9"/>
<meta name="generator" content="Doxygen 1.8.16"/>
<meta name="viewport" content="width=device-width, initial-scale=1"/>
<title>Zonzay: dlib::std_allocator&lt; T, M &gt; Class Template Reference</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="jquery.js"></script>
<script type="text/javascript" src="dynsections.js"></script>
<link href="search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="search/searchdata.js"></script>
<script type="text/javascript" src="search/search.js"></script>
<link href="doxygen.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr style="height: 56px;">
  <td id="projectlogo"><img alt="Logo" src="zonzay.png"/></td>
  <td id="projectalign" style="padding-left: 0.5em;">
   <div id="projectname">Zonzay
   &#160;<span id="projectnumber">1</span>
   </div>
   <div id="projectbrief">Laugh game challenge</div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by Doxygen 1.8.16 -->
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
var searchBox = new SearchBox("searchBox", "search",false,'Search');
/* @license-end */
</script>
<script type="text/javascript" src="menudata.js"></script>
<script type="text/javascript" src="menu.js"></script>
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
$(function() {
  initMenu('',true,false,'search.php','Search');
  $(document).ready(function() { init_search(); });
});
/* @license-end */</script>
<div id="main-nav"></div>
<!-- window showing the filter options -->
<div id="MSearchSelectWindow"
     onmouseover="return searchBox.OnSearchSelectShow()"
     onmouseout="return searchBox.OnSearchSelectHide()"
     onkeydown="return searchBox.OnSearchSelectKey(event)">
</div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<iframe src="javascript:void(0)" frameborder="0" 
        name="MSearchResults" id="MSearchResults">
</iframe>
</div>

<div id="nav-path" class="navpath">
  <ul>
<li class="navelem"><a class="el" href="namespacedlib.html">dlib</a></li><li class="navelem"><a class="el" href="classdlib_1_1std__allocator.html">std_allocator</a></li>  </ul>
</div>
</div><!-- top -->
<div class="header">
  <div class="summary">
<a href="#nested-classes">Classes</a> &#124;
<a href="#pub-types">Public Types</a> &#124;
<a href="#pub-methods">Public Member Functions</a> &#124;
<a href="#pri-attribs">Private Attributes</a> &#124;
<a href="classdlib_1_1std__allocator-members.html">List of all members</a>  </div>
  <div class="headertitle">
<div class="title">dlib::std_allocator&lt; T, M &gt; Class Template Reference</div>  </div>
</div><!--header-->
<div class="contents">
<table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a name="nested-classes"></a>
Classes</h2></td></tr>
<tr class="memitem:"><td class="memItemLeft" align="right" valign="top">struct &#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="structdlib_1_1std__allocator_1_1rebind.html">rebind</a></td></tr>
<tr class="separator:"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table><table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a name="pub-types"></a>
Public Types</h2></td></tr>
<tr class="memitem:afbdfb9dc5c127fd82f2b1c9f3b1989bf"><td class="memItemLeft" align="right" valign="top">typedef std::size_t&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classdlib_1_1std__allocator.html#afbdfb9dc5c127fd82f2b1c9f3b1989bf">size_type</a></td></tr>
<tr class="separator:afbdfb9dc5c127fd82f2b1c9f3b1989bf"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:aedfcf400c07fda90dd1902c6aba1a25a"><td class="memItemLeft" align="right" valign="top"><a id="aedfcf400c07fda90dd1902c6aba1a25a"></a>
typedef std::ptrdiff_t&#160;</td><td class="memItemRight" valign="bottom"><b>difference_type</b></td></tr>
<tr class="separator:aedfcf400c07fda90dd1902c6aba1a25a"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:aa7c4dca5117b25c5f6983cf9ac871b47"><td class="memItemLeft" align="right" valign="top"><a id="aa7c4dca5117b25c5f6983cf9ac871b47"></a>
typedef T *&#160;</td><td class="memItemRight" valign="bottom"><b>pointer</b></td></tr>
<tr class="separator:aa7c4dca5117b25c5f6983cf9ac871b47"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:acfe99966877caf2e39e1164eb6610c1e"><td class="memItemLeft" align="right" valign="top"><a id="acfe99966877caf2e39e1164eb6610c1e"></a>
typedef const T *&#160;</td><td class="memItemRight" valign="bottom"><b>const_pointer</b></td></tr>
<tr class="separator:acfe99966877caf2e39e1164eb6610c1e"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a85421f2355159d8ed9267899edc14a2a"><td class="memItemLeft" align="right" valign="top"><a id="a85421f2355159d8ed9267899edc14a2a"></a>
typedef T &amp;&#160;</td><td class="memItemRight" valign="bottom"><b>reference</b></td></tr>
<tr class="separator:a85421f2355159d8ed9267899edc14a2a"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a29a1ef2015acbcf5023e7f7faf5c135c"><td class="memItemLeft" align="right" valign="top"><a id="a29a1ef2015acbcf5023e7f7faf5c135c"></a>
typedef const T &amp;&#160;</td><td class="memItemRight" valign="bottom"><b>const_reference</b></td></tr>
<tr class="separator:a29a1ef2015acbcf5023e7f7faf5c135c"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a0f9b9e955a601d8d55b59f64da6ca551"><td class="memItemLeft" align="right" valign="top"><a id="a0f9b9e955a601d8d55b59f64da6ca551"></a>
typedef T&#160;</td><td class="memItemRight" valign="bottom"><b>value_type</b></td></tr>
<tr class="separator:a0f9b9e955a601d8d55b59f64da6ca551"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table><table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a name="pub-methods"></a>
Public Member Functions</h2></td></tr>
<tr class="memitem:a86e4c71be54a4d238590b90f61e05c04"><td class="memItemLeft" align="right" valign="top"><a id="a86e4c71be54a4d238590b90f61e05c04"></a>
pointer&#160;</td><td class="memItemRight" valign="bottom"><b>address</b> (reference value) const</td></tr>
<tr class="separator:a86e4c71be54a4d238590b90f61e05c04"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ac67d95f2a1f0d85cd4e0cfc316778b75"><td class="memItemLeft" align="right" valign="top"><a id="ac67d95f2a1f0d85cd4e0cfc316778b75"></a>
const_pointer&#160;</td><td class="memItemRight" valign="bottom"><b>address</b> (const_reference value) const</td></tr>
<tr class="separator:ac67d95f2a1f0d85cd4e0cfc316778b75"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a1e2e802bcf418673b568e11473f71782"><td class="memItemLeft" align="right" valign="top"><a id="a1e2e802bcf418673b568e11473f71782"></a>
&#160;</td><td class="memItemRight" valign="bottom"><b>std_allocator</b> (const <a class="el" href="classdlib_1_1std__allocator.html">std_allocator</a> &amp;)  throw ()</td></tr>
<tr class="separator:a1e2e802bcf418673b568e11473f71782"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:aa26091f7b53d95cbc9687e2cd9003a88"><td class="memTemplParams" colspan="2"><a id="aa26091f7b53d95cbc9687e2cd9003a88"></a>
template&lt;typename U &gt; </td></tr>
<tr class="memitem:aa26091f7b53d95cbc9687e2cd9003a88"><td class="memTemplItemLeft" align="right" valign="top">&#160;</td><td class="memTemplItemRight" valign="bottom"><b>std_allocator</b> (const <a class="el" href="classdlib_1_1std__allocator.html">std_allocator</a>&lt; U, M &gt; &amp;)  throw ()</td></tr>
<tr class="separator:aa26091f7b53d95cbc9687e2cd9003a88"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a6208d9f2629131d7cbb75070bc619806"><td class="memItemLeft" align="right" valign="top"><a id="a6208d9f2629131d7cbb75070bc619806"></a>
<a class="el" href="classdlib_1_1std__allocator.html#afbdfb9dc5c127fd82f2b1c9f3b1989bf">size_type</a>&#160;</td><td class="memItemRight" valign="bottom"><b>max_size</b> () const  throw ()</td></tr>
<tr class="separator:a6208d9f2629131d7cbb75070bc619806"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:aa8bd55902d29ed0c6bd399af7e6af18b"><td class="memItemLeft" align="right" valign="top"><a id="aa8bd55902d29ed0c6bd399af7e6af18b"></a>
pointer&#160;</td><td class="memItemRight" valign="bottom"><b>allocate</b> (<a class="el" href="classdlib_1_1std__allocator.html#afbdfb9dc5c127fd82f2b1c9f3b1989bf">size_type</a> num, typename <a class="el" href="classdlib_1_1std__allocator.html">std_allocator</a>&lt; void, M &gt;::const_pointer=0)</td></tr>
<tr class="separator:aa8bd55902d29ed0c6bd399af7e6af18b"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a1eb12ba5e154a8ece6869bcbb0add873"><td class="memItemLeft" align="right" valign="top"><a id="a1eb12ba5e154a8ece6869bcbb0add873"></a>
void&#160;</td><td class="memItemRight" valign="bottom"><b>construct</b> (pointer p)</td></tr>
<tr class="separator:a1eb12ba5e154a8ece6869bcbb0add873"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a0ccbc8f582451d0d76756f56b97ab3a8"><td class="memItemLeft" align="right" valign="top"><a id="a0ccbc8f582451d0d76756f56b97ab3a8"></a>
void&#160;</td><td class="memItemRight" valign="bottom"><b>construct</b> (pointer p, const T &amp;value)</td></tr>
<tr class="separator:a0ccbc8f582451d0d76756f56b97ab3a8"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a38cecddd14abc89f022a699c28cbdc76"><td class="memItemLeft" align="right" valign="top"><a id="a38cecddd14abc89f022a699c28cbdc76"></a>
void&#160;</td><td class="memItemRight" valign="bottom"><b>destroy</b> (pointer p)</td></tr>
<tr class="separator:a38cecddd14abc89f022a699c28cbdc76"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:aa114ee9e92f5018dd1114104b3e289c0"><td class="memItemLeft" align="right" valign="top"><a id="aa114ee9e92f5018dd1114104b3e289c0"></a>
void&#160;</td><td class="memItemRight" valign="bottom"><b>deallocate</b> (pointer p, <a class="el" href="classdlib_1_1std__allocator.html#afbdfb9dc5c127fd82f2b1c9f3b1989bf">size_type</a>)</td></tr>
<tr class="separator:aa114ee9e92f5018dd1114104b3e289c0"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:acd0b44fea8298332dd625ad0543b9847"><td class="memItemLeft" align="right" valign="top"><a id="acd0b44fea8298332dd625ad0543b9847"></a>
void&#160;</td><td class="memItemRight" valign="bottom"><b>swap</b> (<a class="el" href="classdlib_1_1std__allocator.html">std_allocator</a> &amp;item)</td></tr>
<tr class="separator:acd0b44fea8298332dd625ad0543b9847"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:afe718d3604d9458fa98d54fd0219ad56"><td class="memItemLeft" align="right" valign="top"><a id="afe718d3604d9458fa98d54fd0219ad56"></a>
<a class="el" href="classdlib_1_1std__allocator.html">std_allocator</a> &amp;&#160;</td><td class="memItemRight" valign="bottom"><b>operator=</b> (const <a class="el" href="classdlib_1_1std__allocator.html">std_allocator</a> &amp;)</td></tr>
<tr class="separator:afe718d3604d9458fa98d54fd0219ad56"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table><table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a name="pri-attribs"></a>
Private Attributes</h2></td></tr>
<tr class="memitem:a38efb9abf936b0a87c4a3dd66ffcdcff"><td class="memItemLeft" align="right" valign="top"><a id="a38efb9abf936b0a87c4a3dd66ffcdcff"></a>
M::template <a class="el" href="structdlib_1_1std__allocator_1_1rebind.html">rebind</a>&lt; char &gt;::other&#160;</td><td class="memItemRight" valign="bottom"><b>pool</b></td></tr>
<tr class="separator:a38efb9abf936b0a87c4a3dd66ffcdcff"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table>
<h2 class="groupheader">Member Typedef Documentation</h2>
<a id="afbdfb9dc5c127fd82f2b1c9f3b1989bf"></a>
<h2 class="memtitle"><span class="permalink"><a href="#afbdfb9dc5c127fd82f2b1c9f3b1989bf">&#9670;&nbsp;</a></span>size_type</h2>

<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;typename T , typename M &gt; </div>
      <table class="memname">
        <tr>
          <td class="memname">typedef std::size_t <a class="el" href="classdlib_1_1std__allocator.html">dlib::std_allocator</a>&lt; T, M &gt;::<a class="el" href="classdlib_1_1std__allocator.html#afbdfb9dc5c127fd82f2b1c9f3b1989bf">size_type</a></td>
        </tr>
      </table>
</div><div class="memdoc">
<pre class="fragment">REQUIREMENTS ON M 
    must be an implementation of memory_manager/memory_manager_kernel_abstract.h or
    must be an implementation of memory_manager_global/memory_manager_global_kernel_abstract.h or
    must be an implementation of memory_manager_stateless/memory_manager_stateless_kernel_abstract.h 
    M::type can be set to anything.

WHAT THIS OBJECT REPRESENTS
    This object is an implementation of an allocator that conforms to the C++ standard 
    requirements for allocator objects.  The M template argument is one of the dlib
    memory manager objects and this allocator implementation will do all of its memory allocations
    using whatever dlib memory manager you supply.   

    Thus, using this allocator object you can use any of the dlib memory manager objects with
    the containers in the STL or with any other object that requires a C++ allocator object.

    It is important to note that many STL implementations make the assumption that the memory
    allocated by one allocator can be freed by another.  This effectively means that you should
    only use a global or stateless memory manager with the std_allocator.  Either that or you
    have to verify that your version of the STL isn't going to try and allocate and deallocate
    memory with different allocators.
</pre><p> ! </p>

</div>
</div>
<hr/>The documentation for this class was generated from the following file:<ul>
<li><a class="el" href="std__allocator_8h_source.html">std_allocator.h</a></li>
</ul>
</div><!-- contents -->
<!-- start footer part -->
<hr class="footer"/><address class="footer"><small>
Generated by &#160;<a href="http://www.doxygen.org/index.html">
<img class="footer" src="doxygen.png" alt="doxygen"/>
</a> 1.8.16
</small></address>
</body>
</html>
